#include "csv.h"

CCSVFile::CCSVFile()
{
	rowsize = 0L;
	colsize = 0L;
	datumsize = 0L;
	buffer = (char***)NULL;
};

CCSVFile::~CCSVFile()
{
	ReleaseBuffer();
};

// CSVt@Cǂݍ
bool CCSVFile::LoadBuffer(char *filename)
{
	unsigned long i, j;

	// ɉ炩̃f[^ǂݍłAĂȂ
	if(!CCSVFILE_NOBUFFER())
		return false;

	// t@CI[v
	if((fp = fopen(filename, "r")) == NULL)
		return false;

	// vpeBl擾
	if(!CheckCSV())
		return false;

	// obt@m
	buffer = new char**[rowsize];
	for(i=0;i<rowsize;i++)
	{
		buffer[i] = new char*[colsize];
		for(j=0;j<colsize;j++)
			buffer[i][j] = new char[datumsize];
	}

	// f[^ǂݍ
	if(!ReadData())
		return false;

	//t@CN[Y
	fclose(fp);

	return true;
}

// S
void CCSVFile::ReleaseBuffer()
{
	if(CCSVFILE_NOBUFFER())
		return;

	unsigned long i, j;

	// obt@̉
	for(i=0;i<rowsize;i++)
	{
		for(j=0;j<colsize;j++)
			delete buffer[i][j];
		delete buffer[i];
	}
	delete buffer;

	// l̃Zbg
	rowsize = colsize = datumsize = 0L;
	buffer = (char***)NULL;
	return;
}

bool CCSVFile::CheckCSV()
{
	bool quated = false;
	bool first = true;
	unsigned long rn = 0, cn = 0, dn = 0;
	int state = 0;	 // { 0, 1, 2 } = { 1byte, 2bytȇ1byte, 2bytȇ2byte }
	int c;	// 

	// f[^ɓǂݍłꍇA
	ReleaseBuffer();

	do
	{
		c = getc(fp);

		// Xe[gg̕ύX
		if      ( ( state == 0 ) && ( CCSVFILE_is_sjis1( c ) ) )	state = 1; // 0 -> 1
		else if ( ( state == 1 ) && ( CCSVFILE_is_sjis2( c ) ) )	state = 2; // 1 -> 2
		else if ( ( state == 2 ) && ( CCSVFILE_is_sjis1( c ) ) )	state = 1; // 2 -> 1
		else										state = 0; // 2 -> 0, ̑

		// CSVł̃tH[}bg1byteɈ˂
		if(state == 0)
		{
			if(c == '"')
				quated = !quated;
			if(quated)
			{
				if(c != '"' || (quated && !first))
					if(datumsize < ++dn)
						datumsize = dn;
				first = false;
			}
			else
			{
				if(c == ',')
				{
					if(colsize < ++cn)
						colsize = cn;
					dn = 0;
					first = true;
				}
				else if(c == '\n')
				{
					if(colsize < ++cn)
						colsize = cn;
					if(rowsize < ++rn)
						rowsize = rn;
					cn = 0;
					dn = 0;
					first = true;
				}
				else
				{
					if(c != '"' || quated)
						if(datumsize < ++dn)
							datumsize = dn;
					first = false;
				}
			}
		}
	}while(!feof(fp));

	rewind(fp);

	// Ik'\0'璷
	datumsize++;

	return true;
}

bool CCSVFile::ReadData()
{
	bool quated = false;
	bool first = true;
	unsigned long rn = 0, cn = 0, dn = 0;
	int state = 0;	 // { 0, 1, 2 } = { 1byte, 2bytȇ1byte, 2bytȇ2byte }
	int c;	// 

	do
	{
		c = getc(fp);
		if(c == EOF)
			break;

		// Xe[gg̕ύX
		if      ( ( state == 0 ) && ( CCSVFILE_is_sjis1( c ) ) )	state = 1; // 0 -> 1
		else if ( ( state == 1 ) && ( CCSVFILE_is_sjis2( c ) ) )	state = 2; // 1 -> 2
		else if ( ( state == 2 ) && ( CCSVFILE_is_sjis1( c ) ) )	state = 1; // 2 -> 1
		else										state = 0;	// 2 -> 0, ̑

		// CSVł̃tH[}bg1byteɈ˂
		if(state == 0)
		{
			if(c == '"')
				quated = !quated;
			if(quated)
			{
				if(c != '"' || quated)
					if(c != '"' || !first)
						buffer[rn][cn][dn++] = (char)c;
				first = false;
			}
			else
			{
				if(c == ',')
				{
					buffer[rn][cn++][dn] = '\0';
					dn = 0;
					first = true;
				}
				else if(c == '\n')
				{
					buffer[rn++][cn][dn] = '\0';
					cn = 0;
					dn = 0;
					first = true;
				}
				else
				{
					if(c != '"' || quated)
						buffer[rn][cn][dn++] = (char)c;

					first = false;
				}
			}
		}
	}while(!feof(fp));

	return true;
}

bool CCSVFile::WriteBuffer(char *filename)
{
	unsigned long rn, cn, dn;
	char tmp;
	bool errChar;
	int state;
 
	// obt@Ȃ
	if(CCSVFILE_NOBUFFER())
		return false;

	if((fp = fopen(filename, "a")) == NULL)
		return false;

	for(rn=0;rn<rowsize;rn++)
	{
		for(cn=0;cn<colsize;cn++)
		{
			// ᔽ܂܂`FbN
			errChar = false;
			state = 0;
			for(dn=0;dn<datumsize && buffer[rn][cn][dn] != '\0';dn++)
			{
				// Xe[gg̕ύX
				if      ( ( state == 0 ) && ( CCSVFILE_is_sjis1( buffer[rn][cn][dn] ) ) )	state = 1; // 0 -> 1
				else if ( ( state == 1 ) && ( CCSVFILE_is_sjis2( buffer[rn][cn][dn] ) ) )	state = 2; // 1 -> 2
				else if ( ( state == 2 ) && ( CCSVFILE_is_sjis1( buffer[rn][cn][dn] ) ) )	state = 1; // 2 -> 1
				else															state = 0; // 2 -> 0, ̑

				if(state == 0 && ( (tmp = buffer[rn][cn][dn]) == '\n' || tmp == '\r' || tmp == ',' || tmp == '"' ) )
				{
					errChar = true;
					break;
				}
			}

			// ᔽ܂܂˃NH[g
			errChar && putc('"', fp);

			state = 0;
			// _uNH[e[V͓d˂鏈Ȃ當񏑂o
			for(dn=0;dn<datumsize && buffer[rn][cn][dn] != '\0';dn++)
			{
				// Xe[gg̕ύX
				if      ( ( state == 0 ) && ( CCSVFILE_is_sjis1( buffer[rn][cn][dn] ) ) )	state = 1; // 0 -> 1
				else if ( ( state == 1 ) && ( CCSVFILE_is_sjis2( buffer[rn][cn][dn] ) ) )	state = 2; // 1 -> 2
				else if ( ( state == 2 ) && ( CCSVFILE_is_sjis1( buffer[rn][cn][dn] ) ) )	state = 1; // 2 -> 1
				else															state = 0; // 2 -> 0, ̑

				if(state == 0 && buffer[rn][cn][dn] == '"')
					putc('"', fp);
				putc(buffer[rn][cn][dn], fp);
			}

			// ᔽ܂܂˃NH[g
			errChar && putc('"', fp);
		}
	}
	fclose(fp);

	return true;
}

bool CCSVFile::WriteBuffer(char *filename, char ***data, unsigned long rows, unsigned long cols, unsigned long datumlen)
{
	unsigned long rn, cn, dn;
	if(rows == 0L || cols == 0L || datumlen == 0L || data == (char***)NULL)
		return false;

	// Ƀf[^ꍇA
	ReleaseBuffer();

	// eݒlݒ
	rowsize = rows;
	colsize = cols;
	datumsize = datumlen;
	buffer = new char**[rows];
	for(rn=0;rn<rowsize;rn++)
	{
		buffer[rn] = new char*[cols];
		for(cn=0;cn<colsize;cn++)
		{
			buffer[rn][cn] = new char[datumlen];
			for(dn=0;dn<datumsize;dn++)
				buffer[rn][cn][dn] = data[rn][cn][dn];
		}
	}

	if(filename != NULL)
		if(!WriteBuffer(filename))
			return false;
	return true;
}
